︠19f1766a-570d-4e67-be0c-d93e3b287480i︠
%md
# Tableau and row-insertion (bumping)

## Math 737 - Lab 4

︡8aac881c-2290-458e-828d-bec8d6058ec7︡{"done":true,"md":"# Tableau and row-insertion (bumping)\n\n## Math 737 - Lab 4"}
︠787e2688-3d37-4a47-8d3c-197416b21594i︠
%md
### Note about functions. You do not need to redefine a function to use it on a different object. Define the function once and then you can use it on any object of the right type. An example is given below.
︡3c7fb91e-cc0b-446b-b060-faa53f24a410︡{"done":true,"md":"### Note about functions. You do not need to redefine a function to use it on a different object. Define the function once and then you can use it on any object of the right type. An example is given below."}
︠49e998f0-7d24-4611-ae61-11010143d28ds︠
def square_a_number(num):
    return num^2

square_a_number(5)

square_a_number(7)
︡72ce3948-122a-4800-99f3-1e2107babde1︡{"stdout":"25\n"}︡{"stdout":"49\n"}︡{"done":true}
︠ffff3062-8e42-48e9-8b8b-6273837ac74fi︠
%md
## SYT and SSYT are classes of objects in Sage. Evaluate the cells below to see how to do some things with SYT. Then in Exercise 2, you'll do similar things with SSYT.
︡5164abd9-1b6f-4f1a-86ba-c53eef8cc91d︡{"done":true,"md":"## SYT and SSYT are classes of objects in Sage. Evaluate the cells below to see how to do some things with SYT. Then in Exercise 2, you'll do similar things with SSYT."}
︠d47a3931-15b0-4245-b252-08e504658969ss︠
S = StandardTableaux([3,3])
for tab in S:
    show(tab)
    print("----")
︡42300163-044d-441c-bf64-97965048cea8︡{"file":{"filename":"/tmp/tmpeod8xdzo.png","show":true,"text":null,"uuid":"0c0acac2-76a7-46a5-bfe8-1202bf92abda"},"once":false}︡{"stdout":"----"}︡{"stdout":"\n"}︡{"file":{"filename":"/tmp/tmp7l7faned.png","show":true,"text":null,"uuid":"20475ef7-6407-4ead-a16f-18a8162741b9"},"once":false}︡{"stdout":"----"}︡{"stdout":"\n"}︡{"file":{"filename":"/tmp/tmpcycq1h62.png","show":true,"text":null,"uuid":"d95c5c4f-7e66-4e8e-83c5-d1230e4c588a"},"once":false}︡{"stdout":"----"}︡{"stdout":"\n"}︡{"file":{"filename":"/tmp/tmpu574newf.png","show":true,"text":null,"uuid":"db042c61-841c-45a3-b614-8ddfab7b2173"},"once":false}︡{"stdout":"----"}︡{"stdout":"\n"}︡{"file":{"filename":"/tmp/tmppgvydx4l.png","show":true,"text":null,"uuid":"a69a0e8a-e5b7-47c4-9493-1631f94c6249"},"once":false}︡{"stdout":"----"}︡{"stdout":"\n"}︡{"done":true}
︠c4fbfc3d-12d6-44c2-97c5-acdbc0523c8fo︠
StandardTableaux([6,5,4,3,2,1]).cardinality()
︡5d10572c-7981-4ac8-9bd9-03fe3f70a9b4︡
︠28842941-8613-4959-a116-bc5dc688df54i︠
%md
## Exercise 1: How many SYT are there of shape $[n,n]$, for $n$ ranging from $1$ to $8$? What numbers are these? 

### Hint: Use a 'for' loop. An example of a 'for' loop is given below.

︡4aaab5d2-c624-4003-bfcf-d92a8d9d48ae︡{"done":true,"md":"## Exercise 1: How many SYT are there of shape $[n,n]$, for $n$ ranging from $1$ to $8$? What numbers are these? \n\n### Hint: Use a 'for' loop. An example of a 'for' loop is given below."}
︠dcab18fe-3f48-4734-a419-3da612611c50s︠
for i in [1..10]:
    i^2
︡40363524-469f-43da-9c50-7e7a28e77021︡
︠e1e99e16-ae9c-4677-b508-98f53a450526︠

︡50a6f1a3-3412-4ee6-a2cb-c1e1fe1c2d54︡
︠0538604c-a672-4e2a-b7ab-d406fead4a65i︠
%md
## Exercise 2: Use the command SemistandardTableaux to create (not print!) the set of SSYT there are of shape [3,3] (with entries bounded above by 6). How many tableaux are in this set?

## Then use the optional parameter max_entry to create the set of SSYT of shape [3,3] with entries bounded above by 3. Print this smaller set of SSYT. 

### (If you need help with this, evaluate the cell below to see the documentation.)
︡f011af06-98d1-4dc4-a067-db59fd6888bb︡{"done":true,"md":"## Exercise 2: Use the command SemistandardTableaux to create (not print!) the set of SSYT there are of shape [3,3] (with entries bounded above by 6). How many tableaux are in this set?\n\n## Then use the optional parameter max_entry to create the set of SSYT of shape [3,3] with entries bounded above by 3. Print this smaller set of SSYT. \n\n### (If you need help with this, evaluate the cell below to see the documentation.)"}
︠e8e92814-a20d-4ad9-a4e6-a5b19ba8e3d5so︠
SemistandardTableaux?
︡c9509028-56bb-431c-a8a4-071f4d3ec7e6︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /ext/sage/sage-8.9_1804/local/lib/python2.7/site-packages/sage/misc/lazy_import.pyx\nSignature : SemistandardTableaux(self, x=0, *args, **kwds)\nDocstring :\nA factory class for the various classes of semistandard tableaux.\n\nINPUT:\n\nKeyword arguments:\n\n* \"size\" -- The size of the tableaux\n\n* \"shape\" -- The shape of the tableaux\n\n* \"eval\" -- The weight (also called content or evaluation) of the\n  tableaux\n\n* \"max_entry\" -- A maximum entry for the tableaux.  This can be a\n  positive integer or infinity (\"oo\"). If \"size\" or \"shape\" are\n  specified, \"max_entry\" defaults to be \"size\" or the size of\n  \"shape\".\n\nPositional arguments:\n\n* The first argument is interpreted as either \"size\" or \"shape\"\n  according to whether it is an integer or a partition\n\n* The second keyword argument will always be interpreted as\n  \"eval\"\n\nOUTPUT:\n\n* The appropriate class, after checking basic consistency tests.\n  (For example, specifying \"eval\" implies a value for max_entry).\n\nA semistandard tableau is a tableau whose entries are positive\nintegers, which are weakly increasing in rows and strictly\nincreasing down columns. Note that Sage uses the English convention\nfor partitions and tableaux; the longer rows are displayed on top.\n\nClasses of semistandard tableaux can be iterated over if and only\nif there is some restriction.\n\nEXAMPLES:\n\n   sage: SST = SemistandardTableaux([2,1]); SST\n   Semistandard tableaux of shape [2, 1] and maximum entry 3\n   sage: SST.list()\n   [[[1, 1], [2]],\n    [[1, 1], [3]],\n    [[1, 2], [2]],\n    [[1, 2], [3]],\n    [[1, 3], [2]],\n    [[1, 3], [3]],\n    [[2, 2], [3]],\n    [[2, 3], [3]]]\n\n   sage: SST = SemistandardTableaux(3); SST\n   Semistandard tableaux of size 3 and maximum entry 3\n   sage: SST.list()\n   [[[1, 1, 1]],\n    [[1, 1, 2]],\n    [[1, 1, 3]],\n    [[1, 2, 2]],\n    [[1, 2, 3]],\n    [[1, 3, 3]],\n    [[2, 2, 2]],\n    [[2, 2, 3]],\n    [[2, 3, 3]],\n    [[3, 3, 3]],\n    [[1, 1], [2]],\n    [[1, 1], [3]],\n    [[1, 2], [2]],\n    [[1, 2], [3]],\n    [[1, 3], [2]],\n    [[1, 3], [3]],\n    [[2, 2], [3]],\n    [[2, 3], [3]],\n    [[1], [2], [3]]]\n\n   sage: SST = SemistandardTableaux(3, max_entry=2); SST\n   Semistandard tableaux of size 3 and maximum entry 2\n   sage: SST.list()\n   [[[1, 1, 1]],\n    [[1, 1, 2]],\n    [[1, 2, 2]],\n    [[2, 2, 2]],\n    [[1, 1], [2]],\n    [[1, 2], [2]]]\n\n   sage: SST = SemistandardTableaux(3, max_entry=oo); SST\n   Semistandard tableaux of size 3\n   sage: SST[123]\n   [[3, 4], [6]]\n\n   sage: SemistandardTableaux(max_entry=2)[11]\n   [[1, 1], [2]]\n\n   sage: SemistandardTableaux()[0]\n   []\n\nSee also:\n\n  * \"Tableaux\"\n\n  * \"Tableau\"\n\n  * \"SemistandardTableau\"\n\n  * \"StandardTableaux\"\n\n  * \"StandardTableau\""}}︡{"done":true}
︠cbafdf9a-9b07-43a4-abec-bfd7a6181a54︠

︡2b4eb7fa-b65e-43cb-b8b2-dfd08ecd27c6︡
︠43861fbc-0cba-4dd0-9610-acac616c9667i︠
%md
## Evaluate the cells below to see how to create a SSYT and row-insert numbers into it. 
︡e85e8fa7-8f32-40ad-8bed-f6a20cb9bc4e︡{"done":true,"md":"## Evaluate the cells below to see how to create a SSYT and row-insert numbers into it."}
︠efd0be6b-8d9a-401a-8ae7-c957a7275cd5s︠
T = SemistandardTableau([[1,2,4,11],[3,5,9,12],[6,8],[7],[10]])
show(T)
︡722c1151-84c0-46d6-9b6d-e71f905dc1ca︡
︠f855085c-b27e-45f1-95f6-2c63dd4907e6s︠
show(T.schensted_insert(4))
︡6a2cfffd-3337-4de5-99a1-f2e161774136︡
︠8dd987e3-9afc-4268-9e06-72e8a3d034b2s︠
U = SemistandardTableau([[1,2],[3]])
show(T.bump_multiply(U))
︡32c66b72-d614-4458-b66f-5002e0fcc415︡
︠26eddeac-225c-44ad-b65b-3a37ae9c1991i︠
%md
## Exercise 3: Use the above commands to verify the examples of SSYT mutiplication you did in class on Wednesday in two ways: first, use schensted_insert to insert each number in the second tableau. Then, show that you get the same thing when you use bump_multiply.
︡a36f5dc5-b4f5-4058-9f46-85730d8c2a6d︡{"done":true,"md":"## Exercise 3: Use the above commands to verify the examples of SSYT mutiplication you did in class on Wednesday in two ways: first, use schensted_insert to insert each number in the second tableau. Then, show that you get the same thing when you use bump_multiply."}
︠2957bac5-c3ce-4279-846e-d06b6fabbd90︠

︡c435406f-6953-435c-bddb-1f08bfdb9806︡
︠c14dc4ec-7d4c-44dd-a227-0d6ff8c555b2i︠
%md
## Exercise 4: Is SSYT multiplication commutative? Prove or give a counterexample.
︡6fc43655-a337-44ce-8d30-926c71b376b1︡{"done":true,"md":"## Exercise 4: Is SSYT multiplication commutative? Prove or give a counterexample."}
︠3c206a22-d6a2-4ba1-a645-91c1b9506cbb︠

︡301be1b7-4e5f-454c-b4bd-e082bb38d6b6︡
︠8076dde8-5b2a-487a-a9de-2bdcffcaeecci︠
%md 
## Exercise 5: 

### - Create a random standard Young tableau with 12 boxes. Compute its promotion by hand and by computer (find the correct function using dot+tab). Verify that you got the same thing both ways. Note that there is a promotion command and a promotion_inverse command, so you may need to try both.

### - Verify the orbits of promotion of tableaux of shape (3,3) that you computed by hand.
︡979a1eb1-7f9d-442f-ac88-696418198920︡{"done":true,"md":"## Exercise 5: \n\n### - Create a random standard Young tableau with 12 boxes. Compute its promotion by hand and by computer (find the correct function using dot+tab). Verify that you got the same thing both ways. Note that there is a promotion command and a promotion_inverse command, so you may need to try both.\n\n### - Verify the orbits of promotion of tableaux of shape (3,3) that you computed by hand."}
︠3558b1a1-ff32-4205-aae5-d8cb2755f28b︠
syt = StandardTableaux(12).random_element()
show(syt)
︡c72cd921-5dd3-4c4a-8152-e428387c22a2︡
︠eeb773d9-74c5-437d-8bd4-e6d1b7409b29︠

︡eb682e52-0988-48e7-8757-0884ce4fc8b0︡
︠3a2c2c5c-b27c-429c-aa27-ea79bd297893i︠
%md
## If you have time: Play with the built-in tableaux functions to find some fun things to do with tableaux. Pick your favorite, demonstrate using it, and write a sentence to say what it does. You will share this with the class at the start of the next lab.
︡c77c7897-f653-4a0c-890b-cb441482e1be︡{"done":true,"md":"## If you have time: Play with the built-in tableaux functions to find some fun things to do with tableaux. Pick your favorite, demonstrate using it, and write a sentence to say what it does. You will share this with the class at the start of the next lab."}
︠9cecface-6db6-4586-9fa0-0eab9aca5ad3︠

︠24cd5166-cbf9-4e32-84fa-8246c61155e1︠









